//+------------------------------------------------------------------+
//|                                              .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
    
   
    extern double        Lots = 0.1 ;
    extern int           TrailingStop = 16;        
    extern int           TrailingStep = 10; 
    extern int           Magik        = 55556;
    extern double        MovingPeriod = 24;
    extern double        MovingShift  = 1;
    extern int           RPeriod      = 34;
    extern int           Draw4HowLonng = 1500;

int start()
{
 
  int cnt = 0;
  for (int i = 0; i < OrdersTotal(); i++)
   if (OrderSelect(cnt, SELECT_BY_POS))
     if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magik)
       {
        cnt++;
        if (OrderType() == OP_BUY)
          if (TrailingStop > MarketInfo(Symbol(), MODE_STOPLEVEL))  
            if (Bid - OrderOpenPrice() > Point*TrailingStop)
              if (OrderStopLoss() < Bid - (TrailingStop+TrailingStep-1)*Point)       
                OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
         
        if (OrderType() == OP_SELL)
          if (TrailingStop > MarketInfo(Symbol(), MODE_STOPLEVEL))  
            if (OrderOpenPrice()-Ask > Point*TrailingStop)
              if (OrderStopLoss() > Ask + Point*(TrailingStop+TrailingStep-1) || OrderStopLoss()==0)
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
       }
 
  if (cnt == 0) //    ,     
    {  
     double Green1 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 1, 1);
     double Green2 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 1, 2);
     double Green3 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 1, 3);
     double Red1 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 2, 1);
     double Red2 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 2, 2);
     double Red3 = iCustom(NULL, 0, "LSMA in Color",  RPeriod, Draw4HowLonng, 2, 3);
    
     Print(", Green1 = ", Green1, ", Red1 = ", Red1);
     Print(", Green2 = ", Green2, ", Red2 = ", Red2);
       
     if (Green1 != EMPTY_VALUE && Green2 != EMPTY_VALUE && Green3 == EMPTY_VALUE && Red1 == EMPTY_VALUE) //   - BUY
       OrderSend(Symbol() ,OP_BUY,Lots,NormalizeDouble(Ask, Digits),10,0,0, NULL, Magik, 0, Green);      

     if (Red1 != EMPTY_VALUE && Red2 != EMPTY_VALUE && Red3 == EMPTY_VALUE && Green1 == EMPTY_VALUE)  //   - SELL
       OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid, Digits),10,0,0,NULL,Magik,0,Red);
    }   
      
 return(0);                                                       
}
   
   
   
   
    
  
  
  
  
  
  
      
      